;Blockbuster v4.1 for Ash
;ZoomLabs Software
;Doug Torrance
;profzoom@hotmail.com
;special thanks to Sam Heald for optimizing the code!

	#include ti82.h
	#include keys.inc
	.org START_ADDR
	.db "Blockbuster "
Version:
	.db "v4.1",0
	
; - Variables -

string = TEXT_MEM
lilguyx = TEXT_MEM+6
lilguyy = TEXT_MEM+7
score = TEXT_MEM+8
otherlilguyy = TEXT_MEM+9
yetanotherlilguyy = TEXT_MEM+11
initial = TEXT_MEM+12
RANDSEED = TEXT_MEM+50 ;abitrary
Board = TEXT_MEM+51
: - Title screen -

Beginning:
	call DrawTitlePic			;"Blockbuster v4.1"
	ld hl,TitleScreenInfo
	ld de,$2002
	call vputs				;"Doug Torrance"
	ld d,$27		
	call vputs				;"ZoomLabs Software"
	ld d,$2e
	call vputs				;"profzoom@hotmail.com"
	ld d,$35	
	call vputs				;"High Score - XXX - "
	ld a,(HighScore)
	call DM_HL_DECI				;prints high score


TitleLoop:
	call GET_KEY
	cp G_2nd
	jr z,Help
	cp G_ENTER
	jr z,Help				;go on if 2nd or ENTER is pressed
	cp G_MODE
	ret z					;exit if MODE is pressed
	ld hl,RANDSEED
	inc (hl)				;randomize the RANDSEED
	jr TitleLoop

; - Help screen -

Help:
	call DrawTitlePic
	ld hl,HelpScreenInfo
	ld de,$1d02
	call vputs				;"[RIGHT]&[LEFT]-move"
	ld d,$24
	call vputs				;"[Y=]+[RIGHT]&[LEFT]-jump"
	ld d,$2b
	call vputs				;"[2nd]+[RIGHT],[LEFT],&[DOWN]-"
	ld d,$39
	call vputs				;"break block"
	ld de,$3207
	call vputs				;"[MODE]-exit"

HelpLoop:
	call GET_KEY
	cp G_2nd
	jr z,StartGame
	cp G_ENTER
	jr z,StartGame
	cp G_MODE
	ret z
	ld hl,RANDSEED
	inc (hl)				;randomize the RANDSEED
	jr HelpLoop

; - Draw board -

StartGame:
	ld e,0
	ld hl,Board

WriteBoard:
;getrand.asm by Jason Todd:
  	push hl
	ld hl,(RANDSEED)
	ld a,h
	add a,a
	rl l
	rl h
	add a,a
	rl l
	rl h
	add a,a
	rl l
	rl h
	ld bc,$7415
	add hl,bc
	ld (RANDSEED),hl
	ld a,h
	add a,l
	pop hl
		
	ld (hl),a
	inc hl
	inc e
	ld a,e
	cp 12
	jr nz,WriteBoard
	
LetsGetStarted:	
	ROM_CALL(CLEARLCD)
	ld de,0
	ld hl,Board

DrawRowOfBlocks:				;optimized by Kouri
	ld a,(hl)
	ld b,8
DrawRowLoop:
	rra
	push af
	jr c,DrawBlock
NoBlock:
	ld a,d
	add a,8
	ld d,a
	jr AfterDraw

DrawBlock:
	push bc
	push hl
	ld hl,Block
	call ZoomSprite
	pop hl
	pop bc
AfterDraw:
	pop af
	djnz DrawRowLoop
	inc hl
	ld d,b
	inc e
	ld a,e
	cp 12
	jr nz,DrawRowOfBlocks


DrawManAndExitDoor:
	ld hl,Board
	res 0,(hl)
	ld hl,Board+11
	res 7,(hl)
	ld de,0
	ld hl,Man
	call ZoomSprite
	ld de,$380b
	ld hl,Exit
	call ZoomSprite
	
	xor a
	ld (score),a
	ld (lilguyx),a
	ld (otherlilguyy),a
	inc a
	ld (lilguyy),a
	ld a,%11111110
	ld (yetanotherlilguyy),a
	
Gravity:
	ld a,(otherlilguyy)
	ld d,a
	ld a,(lilguyx)
	ld e,a
	ld hl,Man
	call ZoomSprite
	
	ld a,(otherlilguyy)
	cp 56
	jr z,WaitForKey
	call LoadBoardColumnIntoHL
	ld a,(lilguyy)
	rlca
	ld b,(hl)
	and b
	or a
	jr nz,WaitForKey
	call EraseLilGuy
	ld a,(lilguyy)
	rlca
	ld (lilguyy),a
	ld a,(otherlilguyy)
	add a,8
	ld (otherlilguyy),a
	ld a,(yetanotherlilguyy)
	rlca
	ld (yetanotherlilguyy),a
	jr Gravity

WaitForSecond:
	ld a,$bf
	out (1),a
	in a,(1)
	bit 5,a
	jp z,SecondIsPressed
	bit 4,a
	jp z,YEqualsIsPressed
	
	
	

WaitForKey:
	call GET_KEY
	dec a
	dec a
	jr z,LeftKeyIsPressed
	dec a
	jr z,RightKeyIsPressed
	cp $34
	jp z,Beginning
	ld a,(lilguyy)
	cp %10000000
	jp z,AreYouFinished

GuessNot:
	jr WaitForSecond

LeftKeyIsPressed:
	ld a,(lilguyx)
	or a
	jr z,WaitForKey
	call LoadBoardColumnIntoHL
	dec hl
	ld b,(hl)
	ld a,(lilguyy)
	and b
	or a
	jr nz,WaitForKey
	call EraseLilGuy
	ld hl,lilguyx
	dec (hl)
	jp Gravity	
	

RightKeyIsPressed:
	ld a,(lilguyx)
	cp 11
	jr z,WaitForKey
	call LoadBoardColumnIntoHL
	inc hl
	ld a,(lilguyy)
	and (hl)
	or a
	jr nz,WaitForKey
	call EraseLilGuy
	ld hl,lilguyx
	inc (hl)
	jp Gravity	

YEqualsIsPressed:
	ld a,$fe
	out (1),a
	in a,(1)
	bit 1,a
	jr z,YEqualsLeftIsPressed
	bit 2,a
	jr z,YEqualsRightIsPressed
	jp WaitForSecond

YEqualsRightIsPressed:
	ld a,(lilguyx)
	cp 11
	jr z,WaitForKey
	ld a,(otherlilguyy)
	or a
	jr z,WaitForKey
	call LoadBoardColumnIntoHL
	inc hl
	ld a,(lilguyy)
	rrca
	and (hl)
	or a
	jp nz,WaitForKey
	call EraseLilGuy
	;ld a,(lilguyx)
	;inc a
	;ld (lilguyx),a
	ld hl,lilguyx
	inc (hl)
	ld a,(lilguyy)
	rrca
	ld (lilguyy),a
	ld a,(otherlilguyy)
	sub 8
	ld (otherlilguyy),a
	ld a,(yetanotherlilguyy)
	rrca
	ld (yetanotherlilguyy),a
	jp GiveSufficientTime

YEqualsLeftIsPressed:
	ld a,(lilguyx)
	or a
	jp z,WaitForKey
	ld a,(otherlilguyy)
	or a
	jp z,WaitForKey
	call LoadBoardColumnIntoHL
	dec hl
	ld a,(lilguyy)
	rrca
	and (hl)
	or a
	jp nz,WaitForKey
	call EraseLilGuy
	ld hl,lilguyx
 	dec (hl)
	ld a,(lilguyy)
	rrca
	ld (lilguyy),a
	ld a,(otherlilguyy)
	sub 8
	ld (otherlilguyy),a
	ld a,(yetanotherlilguyy)
	rrca
	ld (yetanotherlilguyy),a
	jp GiveSufficientTime

SecondIsPressed:
	ld a,$fe
	out (1),a
	in a,(1)
	bit 1,a
	jr z,SecondLeftIsPressed
	bit 2,a
	jr z,SecondRightIsPressed
	bit 0,a
	jr z,SecondDownIsPressed
	jp WaitForSecond

SecondLeftIsPressed:
	ld a,(lilguyx)
	or a
	jp z,WaitForKey
	call LoadBoardColumnIntoHL
	dec hl
	ld a,(lilguyy)
	and (hl)
	or a
	jp z,WaitForKey
	ld a,(yetanotherlilguyy)
	and (hl)
	ld (hl),a
	ld a,(otherlilguyy)
	ld d,a
	ld a,(lilguyx)
	dec a
	call DispNothing
	ld hl,score
	inc (hl)
	call GET_KEY
	jp WaitForKey

SecondRightIsPressed:
	ld a,(lilguyx)
	cp 11
	jp z,WaitForKey
	call LoadBoardColumnIntoHL
	inc hl
	ld a,(lilguyy)
	and (hl)
	or a
	jp z,WaitForKey
	ld a,(yetanotherlilguyy)
	and (hl)
	ld (hl),a
	ld a,(otherlilguyy)
	ld d,a
	ld a,(lilguyx)
	inc a
	call DispNothing
	ld hl,score
 	inc (hl)
	call GET_KEY
	jp WaitForKey	

SecondDownIsPressed:
	ld a,(otherlilguyy)
	cp 56
	jp z,WaitForKey
	call LoadBoardColumnIntoHL
	ld a,(lilguyy)
	rlca
	and (hl)
	or a
	jp z,WaitForKey
	ld a,(yetanotherlilguyy)
	rlca
	and (hl)
	ld (hl),a
	ld a,(otherlilguyy)
	add a,8
	ld d,a
	ld a,(lilguyx)
	call DispNothing
	ld hl,score
 	inc (hl)
	ld bc,0

GiveSufficientTime:
	inc b
	ld a,b
	cp $ff
	jr nz,GiveSufficientTime
	inc c
	ld a,c
	cp $80
	jr nz,GiveSufficientTime
	jp Gravity

AreYouFinished:
	ld a,(lilguyx)
	cp 11
	jp nz,GuessNot
	
YouAreFinished:
	ld de,$c20
	ld hl,YourScore
	call vputs
	ld a,(score)
	call DM_HL_DECI
	ld hl,HighScore
	ld a,(score)
	cp (hl)
	jr z,Loop
	jr nc,YouGotTheHighScore
	
Loop:
	call GET_KEY
	cp 9
	jp z,Beginning
	cp $37
	jp z,Beginning
	jr Loop

YouGotTheHighScore:
	ld de,$1300
	ld hl,CongratulationsHighScore
	call vputs
	ld de,$1913
	call vputs
	ld hl,HighScore
	ld a,(score)
	ld (hl),a
	ld de,0
	
	
NewInitial:
	ld hl,$0604
	ld (CURSOR_ROW),hl
	ld hl,HighScoreBuffer
	add hl,de
	push hl
	ld hl,HighScoreBuffer-1
	call SAM 
	pop hl
	push hl
	ld a,e
	or a
	call z,HighlightFirstLetter
	dec a
	call z,HighlightSecondLetter
	dec a
	call z,HighlightThirdLetter
	pop hl
	
	
EnterInitials:
	push hl
	call GET_KEY
	pop hl
	dec a
	jr z,EI_DownIsPressed
	dec a
	jr z,EI_LeftIsPressed
	dec a
	jr z,EI_RightIsPressed
	dec a
	jr z,EI_UpIsPressed
	cp 5
	jp z,Beginning
	jr EnterInitials

EI_UpIsPressed:
	inc (hl)
	ld a,(hl)
	cp $5b
	jr nz,NewInitial
	ld (hl),$41
	jr NewInitial

EI_DownIsPressed:
	dec (hl)
	ld a,(hl)
	cp $40
	jr nz,NewInitial
	ld (hl),$5a
	jr NewInitial

EI_RightIsPressed:
	ld a,e
	cp 3
	jr z,NewInitial
	inc e
	jr NewInitial

EI_LeftIsPressed:
	ld a,e
	or a
	jr z,EnterInitials
	dec e
	jr NewInitial
	



; - Calls -

DrawTitlePic:					;optimized by Sam Heald and OBD
	ld hl,Titlepic	  			;big "Blockbuster" picture
	ld de,GRAPH_MEM
	ld bc,192
	ldir
	ld hl,GRAPH_MEM+191
	ld (hl),b
	ld bc,575
	ldir
	ROM_CALL(DISP_GRAPH)



ContinueWritingTitle:
	ld de,$1404
	ld hl,Man				
	call ZoomSprite				;draw man
	ld de,$1405
	ld hl,Block
	call ZoomSprite				;draw block
	ld de,$0c02
      	ld hl,Version
	ld (CURSOR_ROW),de
	ROM_CALL(D_ZT_STR)			;"v4.1"
	ret					
	

HighlightFirstLetter:
	call SAM_INVERT
	inc hl
	call SAM
	inc hl
	jr SAM
	
HighlightSecondLetter:
	dec hl
	call SAM
	inc hl
	call SAM_INVERT
	inc hl
	call SAM
	inc hl
	ret

HighlightThirdLetter:
	dec hl
	dec hl
	call SAM
	inc hl
	call SAM
	inc hl
	call SAM_INVERT
	inc hl
	inc hl
	ret

SAM:
	ld a,(hl)
	ROM_CALL(TX_CHARPUT)
	ret

SAM_INVERT:
	set 3,(iy+5)
	call SAM
	res 3,(iy+5)
	ret

LoadBoardColumnIntoHL:
	ld d,0
	ld a,(lilguyx)
	ld e,a
	ld hl,Board
	add hl,de
	ret

EraseLilGuy:
	ld a,(otherlilguyy)
	ld d,a
	ld a,(lilguyx)

DispNothing:
	ld e,a
	ld hl,Nothing
ZoomSprite:
	
	ld b,8

ZS_Draw:	
	ld a,$20
	add a,e
	call $7f3
	out ($10),a
	ld a,$80
	add a,d
	call $7f3
	out ($10),a
	ld a,(hl)
	call $7f3
	out ($11),a
	inc d
	inc hl
	djnz ZS_Draw
	ret

;--- Jimmy Mardell's DM_HL_DECI Code
DM_HL_DECI:
	ld l,a
 	ld h,0
	ld de, string+5
	xor a
	ld (de), a
DM_HL_DECI_Repeat:
	call UNPACK_HL
	add a, '0'
	dec de
	ld (de), a
	ld a, h
	or l
	jr nz, DM_HL_DECI_Repeat
	ex de, hl
	jr vputs2

vputs:
	ld (CURSOR_X),de			;set cursor position
vputs2:
	ROM_CALL(D_ZM_STR)			;write text
	ret


; - Strings -

TitleScreenInfo:	
	.db "Doug Torrance",0
	.db "ZoomLabs Software",0
	.db "profzoom@hotmail.com",0
	.db "High Score - "

HighScoreBuffer:
	.db "DAT - ",0

HighScore:
	.db 0

HelpScreenInfo:
	.db $c1,$cf,"]&",$c1,5,"]-move",0
	.db $c1,"Y=]+",$c1,$cf,"]&",$c1,5,"]-jump",0
	.db $c1,"2nd]+",$c1,$cf,"],",$c1,5,"]&",$c1,7,"]-",0
	.db $c1,"MODE]-exit",0
	.db "break block",0

YourScore:
	.db "Score-",0

CongratulationsHighScore:
	.db "Congratulations!  High Score!",0
	.db "Enter your initials..."

; - Sprites -

Nothing:	;just a blank 8x8 sprite, and since first 8 bytes of Titlepic are 0, I can save some space!			
Titlepic:	;Created using .82I to .ASM Convertor v1.0 by Wouter Demuynck (kadem@unicall.be)
	.db $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
	.db $1E,$01,$80,$00,$03,$00,$C0,$00,$00,$00,$00,$00
	.db $3F,$C1,$C0,$00,$03,$80,$E0,$00,$00,$00,$00,$00
	.db $3C,$E1,$C0,$00,$03,$80,$E0,$00,$00,$08,$00,$00
	.db $38,$F1,$C0,$00,$03,$80,$E0,$00,$00,$08,$00,$00
	.db $38,$71,$C3,$00,$C3,$88,$F8,$00,$07,$1E,$18,$24
	.db $38,$F1,$CF,$C3,$F3,$98,$FE,$31,$9F,$BE,$7E,$7E
	.db $3F,$F1,$DC,$E6,$73,$E0,$FF,$31,$DD,$9E,$CF,$7E
	.db $3F,$F1,$DC,$76,$33,$C0,$FF,$39,$DC,$1C,$FF,$7C
	.db $3C,$F1,$DC,$7E,$03,$E0,$E7,$F9,$DF,$1C,$FF,$78
	.db $38,$79,$FC,$3F,$03,$F0,$E3,$F9,$CF,$9C,$E0,$78
	.db $38,$79,$FC,$3F,$13,$F0,$E3,$F9,$C7,$DC,$E0,$70
	.db $38,$79,$DC,$7F,$B3,$F8,$E7,$3B,$D1,$DE,$F6,$70
	.db $7F,$F1,$CE,$F7,$F3,$FC,$FF,$3F,$DB,$DE,$FE,$78
	.db $7F,$E1,$C7,$83,$F3,$9C,$78,$1F,$DF,$8E,$7E,$78
	.db $18,$00,$00,$00,$E0,$00,$00,$08,$00,$04,$1C

Man:	;new grafx thanx to Blackbelt, make the game look a bit nicer (from 83 version)
	.db %01111100
	.db %10101010
	.db %00010000
	.db %00111000
	.db %01111100
	.db %10111010
	.db %00010000
	.db %01101100
		
Block:
	.db %01111110
	.db %11010101
	.db %10101011
	.db %11010101
	.db %10101011
	.db %11010101
	.db %10101011
Exit:	.db %01111110
	
	.db %11111111
	.db %11000011
	.db %11000011
	.db %11000011
	.db %11000011
	.db %11000011
	.db %11000011

.end